/*
		Copyright (C) 2013 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

		This library is free software; you can redistribute it and/or
		modify it under the terms of the GNU Lesser General Public
		License as published by the Free Software Foundation; either
		version 2.1 of the License, or (at your option) any later version.

		This library is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
		Lesser General Public License for more details.

		You should have received a copy of the GNU Lesser General Public
		License along with this library; if not, write to the Free Software
		Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
		MA 02110-1301  USA.
*/

#ifndef ECHARTBASEQML_H
#define ECHARTBASEQML_H

#include <qglobal.h>

#if QT_VERSION >= 0x050000
#include <QQuickPaintedItem>

class QPainter;
#else
#include <QGraphicsProxyWidget>
#endif
#include "echarts.h"

class EChartBase;

/**
	* @brief The base QML export class for EChart widgets
	*/
#if QT_VERSION >= 0x050000
class E_CHARTS_EXPORT EChartBaseQml : public QQuickPaintedItem
#else
class E_CHARTS_EXPORT EChartBaseQml : public QGraphicsProxyWidget
#endif
{
	Q_OBJECT
	Q_PROPERTY(QString chartTitle READ chartTitle WRITE setChartTitle)
	Q_PROPERTY(int numberPrecision READ numberPrecision WRITE setNumberPrecision)
	Q_PROPERTY(char numberFormat READ numberFormat WRITE setNumberFormat)
	Q_PROPERTY(QFont titleFont READ titleFont WRITE setTitleFont)
	Q_PROPERTY(QFont labelFont READ labelFont WRITE setLabelFont)
	public:
#if QT_VERSION >= 0x050000
		EChartBaseQml(EChartBase *eChartWidget, QQuickItem *parent = NULL);
#else
		EChartBaseQml(EChartBase *eChartWidget, QGraphicsItem *parent = NULL);
#endif

		void setChartTitle(QString chartTitle);
		QString chartTitle() const;
		void setNumberPrecision(int precision);
		int numberPrecision() const;
		void setNumberFormat(char format);
		char numberFormat() const;

//		void addDataSet(EChartValues dataSet, const QString label, QColor color = QColor());
		bool removeDataSet(const QString label);

		void setTitleFont(QFont font);
		QFont titleFont() const;
		void setLabelFont(QFont font);
		QFont labelFont() const;
		
		
#if QT_VERSION >= 0x050000
		void paint(QPainter * painter);
#endif

	public slots:
		void clear();

	protected:
		EChartBase *eChartBase;
};

#endif // ECHARTBASEQML_H
