/*
    Copyright (C) 2012 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
    MA 02110-1301  USA.
*/

#ifndef ECHARTVALUES_H
#define ECHARTVALUES_H

#include "echarts.h"

#include <QList>
#include <QVariant>

/**
	* @brief Class to store x and y values vectors
	* @ingroup Charts
	*/
class E_CHARTS_EXPORT EChartValues
{
	public:
		EChartValues();
		EChartValues(const QVariant x, const QVariant y);

		void add(QVariant x, QVariant y);
		inline QList<QVariant> xValues() const { return myXValues; }
		QVariant y(const QVariant x) const;

	private:
		QList<QVariant> myXValues;
		QList<QVariant> myYValues;
};

#endif // ECHARTVALUES_H
