/*
    Copyright (C) 2010 - 2012 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
    MA 02110-1301  USA.
*/

#ifndef EABOUTMODEL_H
#define EABOUTMODEL_H

#include "eglobal.h"
#include "eabstractitemmodel.h"

#include "eaboutperson.h"

/**
	* @brief Used by the EAboutDialog to display all related persons.
	*
	* Normally the only thing you have to do, is to add
	* EAboutPerson's via addPerson().
	*/
class E_CORE_EXPORT EAboutModel : public EAbstractItemModel
{
	Q_OBJECT
	public:
		EAboutModel(QObject *parent = 0);
		~EAboutModel();
		
		QString toHtml() const;
		void addPerson(EAboutPerson *person);
		void addPerson(QString name, QString givenName, EAboutPerson::Categories categories);
		void addPerson(QString name, QString givenName, QString email, EAboutPerson::Categories categories);
		EAboutPerson *itemFromIndex(QModelIndex index) const;
		
		// standard api
		QVariant data(const QModelIndex& index, int role = Qt::DisplayRole) const;
		int columnCount(const QModelIndex& parent = QModelIndex()) const;
		int rowCount(const QModelIndex& parent = QModelIndex()) const;
		QModelIndex parent(const QModelIndex& child) const;
		QModelIndex index(int row, int column, const QModelIndex& parent = QModelIndex()) const;
		QVariant headerData(int section, Qt::Orientation orientation, int role = Qt::DisplayRole) const;
		
	private:
		EngSaS::AboutPersons items;
};

#endif // EABOUTMODEL_H