/*
    Copyright (C) 2010 - 2012 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
    MA 02110-1301  USA.
*/

#ifndef EDEPENDENCIESDIALOG_H
#define EDEPENDENCIESDIALOG_H

#include "eglobal.h"
#include "edialog.h"

namespace Ui {
	class EDependenciesDialog;
}

class EDependencyModel;

#include <QModelIndex>

/**
	* @brief Used to display dependencies of used software.
	*
	* @note The given EDependencyModel is deleted at the destructor of this class.
	*/
class E_CORE_EXPORT EDependenciesDialog : public EDialog
{
	Q_OBJECT
	public:
		/**
			* @note The given EDependencyModel @p model is deleted at the destructor of this class.
			*/
    EDependenciesDialog(EDependencyModel *model, QWidget* parent = 0, Qt::WindowFlags flags = 0);
    ~EDependenciesDialog();

	private slots:
		void contextMenu(QPoint pos);
		/**
			* @brief Called on double clicks onto the model.
			*
			* If column three is double clicked, it calls openWebsite().
			*/
		void doubleClicked(QModelIndex index);
		/**
			* @brief Tries to open website for index curIndex.
			*
			* If website is not empty and curIndex is valid,
			* it opens the given URL.
			*/
		void openWebsite();
		
	private:
		Ui::EDependenciesDialog* ui;
		EDependencyModel *model;
		QModelIndex curIndex;
};

#endif // EDEPENDENCIESDIALOG_H
