/*
    Copyright (C) 2010 - 2012 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
    MA 02110-1301  USA.
*/

#ifndef EDEPENDENCYITEM_H
#define EDEPENDENCYITEM_H

#include "eglobal.h"
#include "exmlitem.h"

class EXmlModel;

class E_CORE_EXPORT EDependencyItem : public EXmlItem
{
	Q_OBJECT
	public:
		inline EDependencyItem(EXmlItem *parent = NULL) : EXmlItem("dependency", parent) { }

		static EXmlItem *create(EXmlModel *model);
		
		QVariant data(int column, int role = Qt::DisplayRole) const;
    bool load(const QDomElement element, QMap< QString, EXmlParserItem* > parser);
    bool save(QDomElement& useElem);
		
		void setName(QString name);
		QString name() const;
		void setVersion(QString version);
		QString version() const;
		void setWebsite(QString url);
		QString website() const;
		
		EXmlItem *copy() const;
		
	private:
		QString myName, myVersion, myWebsite;
};

#endif // EDEPENDENCYITEM_H
