/*
		Copyright (C) 2014 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

		This library is free software; you can redistribute it and/or
		modify it under the terms of the GNU Lesser General Public
		License as published by the Free Software Foundation; either
		version 2.1 of the License, or (at your option) any later version.

		This library is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
		Lesser General Public License for more details.

		You should have received a copy of the GNU Lesser General Public
		License along with this library; if not, write to the Free Software
		Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
		MA 02110-1301  USA.
*/

#ifndef EHEADERVIEWCUSTOM_H
#define EHEADERVIEWCUSTOM_H

#include "eheaderviewbase.h"
#include "eglobal.h"

/**
	* @brief Displays the headers set with setHeaders() instead of the header from the model.
	*
	* @see EHeaderViewSpanned
	* @see EHeaderViewVerticalText
	*/
class E_CORE_EXPORT EHeaderViewCustom : public EHeaderViewBase
{
	Q_OBJECT
	public:
		EHeaderViewCustom(Qt::Orientation orientation, QWidget * parent = NULL);
		EHeaderViewCustom(QStringList headerList, Qt::Orientation orientation, QWidget * parent = NULL);

		void setHeaders(QStringList headerList);
		QSize sectionSizeFromContents(int logicalIndex) const;

	protected:
		void paintSection(QPainter *painter, const QRect &rect, int logicalIndex) const;

	private:
		QStringList _headerList;
};

#endif // EHEADERVIEWCUSTOM_H
