/*
    Copyright (C) 2010 - 2012 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
    MA 02110-1301  USA.
*/


#ifndef EMODULESTATEWIDGET_H
#define EMODULESTATEWIDGET_H

#include "ewidget.h"
#include "eglobal.h"

class EModuleListWidgetItem;

namespace Ui
{
  class EModuleStateWidget;
}

class QListWidgetItem;

/**
  * @brief Shows some information about the loading process of each found module.
  */
class E_CORE_EXPORT EModuleStateWidget : public EWidget
{
    Q_OBJECT
  public:
    EModuleStateWidget ( EngSaS::ModuleListWidgetItems protocol, QWidget *parent = 0 );
    ~EModuleStateWidget();
		void setViewOnly();

  protected:
    void changeEvent ( QEvent *e );

  private slots:
    void itemClickedByPass ( QListWidgetItem *item );

  private:
    Ui::EModuleStateWidget *ui;
    EngSaS::ModuleListWidgetItems protocol;

    void convertProtocol();

  signals:
    void itemClicked ( EModuleListWidgetItem *item );
};

#endif // EMODULESTATEWIDGET_H
