/*
    Copyright (C) 2010 - 2012 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
    MA 02110-1301  USA.
*/
#ifndef ESCALEDIMAGE_H
#define ESCALEDIMAGE_H

#include "eglobal.h"
#include <QLabel>
#include <QPixmap>

/**
	* @brief A QLabel to display scaled and resizeable images.
	*
	* We use QPixmaps in all public functions, to avoid using QPixmaps
	* outside of display classes. This is because QPixmaps are not thread safe,
	* since they need GUI elements.
	*/
class E_CORE_EXPORT EScaledImage : public QLabel
{
	Q_OBJECT
	public:
		EScaledImage(QImage image, QWidget *parent = 0, Qt::WindowFlags flags = 0);
		EScaledImage(QWidget *parent = 0, Qt::WindowFlags flags = 0);
		void setImage(QImage image);
		QImage image();
		/**
			* @brief Replacement of QLabel::setPixmap(QPixmap) which uses QImage.
			*/
		void setPixmap(QImage image);
	
	protected:
		void resizeEvent ( QResizeEvent* event );
		
	private:
		QImage myImage;
};

#endif // ESCALEDIMAGE_H
