/*
		Copyright (C) 2013 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

		This library is free software; you can redistribute it and/or
		modify it under the terms of the GNU Lesser General Public
		License as published by the Free Software Foundation; either
		version 2.1 of the License, or (at your option) any later version.

		This library is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
		Lesser General Public License for more details.

		You should have received a copy of the GNU Lesser General Public
		License along with this library; if not, write to the Free Software
		Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
		MA 02110-1301  USA.
*/

#ifndef ECLOSEMODALWIDGETEVENT_H
#define ECLOSEMODALWIDGETEVENT_H

#include "etesting.h"

#include <QString>

class QEvent;

/**
	* @brief Class to handle events send by the ECloseModelWidgetThread to the modal dialog.
	*
	* If objectName is empty, the modal widget itself is addressed, otherwise a child of the modal
	* widget with object name objectName is searched and (if found) used.
	*/
class E_TESTING_EXPORT ECloseModalWidgetEvent {
	public:
		ECloseModalWidgetEvent(QString objectName, QEvent *event);

		QString objectName;
		QEvent *event;
};

typedef QList<ECloseModalWidgetEvent> ECloseModalWidgetEvents;

#endif // ECLOSEMODALWIDGETEVENT_H
